import fs from "fs";
import grabDirNames from "./names/grab-dir-names";
import type { ConnectionConfig } from "mariadb";
import path from "path";

type Return = ConnectionConfig["ssl"] | undefined;

/**
 * # Grab SSL
 */
export default function grabDbSSL(): Return {
    let maxscaleSSLCaCertFileFinal;

    try {
        const { maxscaleSSLCaCertFile } = grabDirNames();
        maxscaleSSLCaCertFileFinal = maxscaleSSLCaCertFile;
    } catch (error) {}

    const caProivdedPath =
        process.env.DSQL_SSL_CA_CERT || maxscaleSSLCaCertFileFinal;

    if (!caProivdedPath?.match(/./)) {
        return undefined;
    }

    const caFilePath = path.resolve(process.cwd(), caProivdedPath);

    if (!fs.existsSync(caFilePath)) {
        console.log(`${caFilePath} does not exist`);
        return undefined;
    }

    return {
        ca: fs.readFileSync(caFilePath),
        rejectUnauthorized: false,
    };
}
